Rem
	Langtons Ameise
	1. Ändert beim Betreten die Farbe von schwarz zu weiß und umgekehrt
	2. Betritt weißes Feld -> rechts
	3. Betritt schwarzes Feld -> links
	4. Wandert sie aus dem Feld heraus kommt sie auf die gegenüberliegende Seite.

EndRem

SuperStrict

Include "bmx-json/json.bmx"  '* https://github.com/FailedCode/bmx-json

AppTitle = "Langtons Ameise"
Global gfx_w:Int = 800
Global gfx_h:Int = 600
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(59)

Global mx:Int, my:Int, mh:Int[4], key:Int[256], ms:Int
Global GridSize:Int = 16
Global TheGrid_w:Int = gfx_w / GridSize
Global TheGrid_h:Int = gfx_h / GridSize
Global StartPos:TPos, Turn:Int=0
	
Local json:TJsonNode = TJsonNode.Create(LoadString("options.json"))
if json then
	gfx_w = int( json.xPath("window/width") )
	gfx_h = int( json.xPath("window/height") )
	GridSize = int( json.xPath("gridsize") )
	TheGrid_w:Int = gfx_w / GridSize
	TheGrid_h:Int = gfx_h / GridSize

	Select json.xPath("startposition")
		Case "center"
			StartPos = TPos.Create(TheGrid_w/2, TheGrid_h/2)
		Case "top-left"
			StartPos = TPos.Create(0, 0)
		Case "top-right"
			StartPos = TPos.Create(TheGrid_w-1, 0)
		Case "bottom-left"
			StartPos = TPos.Create(0, TheGrid_h-1)
		Case "bottom-right"
			StartPos = TPos.Create(TheGrid_w-1, TheGrid_h-1)
	EndSelect
	
endif

if StartPos = null then
	StartPos = TPos.Create(TheGrid_w/2, TheGrid_h/2)
endif

Graphics(gfx_w, gfx_h, 0, 60)
SetColor(0, 0, 0)
SetClsColor(255, 255, 255)
SetBlend(ALPHABLEND)

Type TPos
	Field x:Int, y:Int

	Function Create:TPos(_x:Int, _y:Int)
		Local o:TPos = new TPos
		o.x = _x
		o.y = _y
		return o
	EndFunction

	Method toString:String()
		return "("+self.x+","+self.y+")"
	EndMethod
	

	Method Add(_pos:TPos)
		self.x :+ _pos.x
		self.y :+ _pos.y
	EndMethod
EndType


Type TAmeise 
	field p:TPos
	field rotation:Int

	Global North:TPos = TPos.Create(0, -1)
	Global West:TPos = TPos.Create(1, 0)
	Global South:TPos = TPos.Create(0, 1)
	Global East:TPos = TPos.Create(-1, 0)

	Function Create:TAmeise( _pos:TPos, _rot:Int = 0 )
		Local o:TAmeise = new TAmeise
		o.p = _pos
		o.rotation = _rot
		return o
	EndFunction

	Method Move()
		Select self.rotation
			Case 0
				self.p.Add( TAmeise.North )
			Case 1
				self.p.Add( TAmeise.West )
			Case 2
				self.p.Add( TAmeise.South )
			Case 3
				self.p.Add( TAmeise.East )
		EndSelect

		'* Über den Rand hinauslaufen:
		if self.p.x < 0 		 then self.p.x :+ TheGrid_w
		if self.p.x => TheGrid_w then self.p.x :- TheGrid_w
		if self.p.y < 0 		 then self.p.y :+ TheGrid_h
		if self.p.y => TheGrid_h then self.p.y :- TheGrid_h
	EndMethod

	Method Update()
		Turn:+1

		'* Betretenes Feld angucken:
		if TheGrid[self.p.x, self.p.y] = 0 then
			'* weiß -> rechts
			self.rotation = (self.rotation + 1 + 4) mod 4
		else
			'* schwarz -> links
			self.rotation = (self.rotation - 1 + 4) mod 4
		endif

		'* Umfärben:
		TheGrid[self.p.x, self.p.y] :~ 1

		'* Bewegen:
		self.Move()
	EndMethod
	
EndType

Global TheGrid:Byte[TheGrid_w, TheGrid_h]
Global ant:TAmeise = TAmeise.Create( StartPos )

Function RenderGrid()

	for Local y:Int=0 Until TheGrid_h 
		for Local x:Int=0 Until TheGrid_w

			if TheGrid[x,y] = 0 then
				SetColor(255,255,255)
			Else
				SetColor(0,0,0)
			endif

			DrawRect(x*GridSize, y*GridSize, GridSize, GridSize)

		next 
	next

EndFunction

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	For Local i:Int = 1 Until mh.length
		mh[i] = MouseHit(i)
	Next
	For Local i:Int = 0 Until key.length
		key[i] = KeyHit(i)
	Next

	RenderGrid()

	ant.Update()
	
	SetColor(128,128,255)
	SetBlend(SOLIDBLEND)
	DrawText(Turn, 10, 10)
	SetBlend(ALPHABLEND)

	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End 